theme: ../theme.json
author: J4YC33
date: August 2021
paging: Learning Opportunity %d / %d
---
# Linux 101
## Module 1 - Getting Started
---
# What is Linux?
* Linux is a family of operating systems based on the linux kernel
* This family of operating systems is generally
 * Open Source
 * Community Driven
 * Cross Compatible
---
# Linux Philosophy

1. Small is Beautiful
2. Each Program Does One Thing Well
3. Prototype as Soon as Possible
4. Choose Portability Over Efficiency
5. Store Data in Flat Text Files
6. Use Software Leverage
7. Use Shell Scripts to Increase Leverage and Portability
8. Avoid Captive User Interfaces
9. Make Every Program a Filter
---
# Linux Philosophy (cont.)
* Essentially, the linux philosophy can be boiled down to simplicity,
 efficiency, and freedom. 
* The Linux Philosophy both informs and echoes the FLOSS philosophy
 * Free (Libre) Open Source Software
---
# Linux Origins
* Linux was spawned from the early days of AT&T Unix, and the early GNU days
* In 1992 Linus Torvalds established the first linux kernel
 * It printed 4 of each letter to the screen (AAAA BBBB CCCC ...) 
* Since then, it's become a beast of an operating system that powers most
 of the world's servers
---
# The Linux Operating System
* In this course, we are mostly going to be using the Debian Operating System
* It is assumed you have access to a working Debian System
* Debian is a Linux Operating System 
---
# The Linux Operating System (cont.)
* The Linux Operating System exists as a collection of files
* In abstract, pretty much the whole operating system can be considered a 
 collection of files
* In effect, the linux operating system is all a series of methods of 
 manipulating and reading files
* This might not make much sense now, but I promise it will help glue 
 everything together
---
# Flavors of Linux
* There are multiple different flavors, or distribution families, of linux 
* Largely these are very similar to each other and often differ in 
 * Package Management
 * Built In Tools
 * GUI Options
 * Purpose-built Modules
* The Red Hat, Debian, and Suse families are 3 major families of linux
---
# Using the Linux Operating System
* Our first step in using the basic Linux operating system is that we 
 will not be using a GUI
* Become comfortable with the "Command Line Interface" or CLI
* We're going to talk about a fairly advanced command that you will 
 use very basically and grow to love. 
---
# Terminal MUltipleXer
* The command `tmux` can be used to have multiple terminal windows open in a CLI. 
* Write all of these instructions down before you go.
1. Close the presentation
2. Run the `tmux` command
3. Press `CTRL+b` and then press `%`
4. Press `CTRL+b` followed by the left and right arrow keys to swap windows
5. Return to the slideshow in one of windows
---
# Tmux
* At this point, you should have the slides on one side of your terminal and
another usable terminal on the other side of the screen. 
* This will allow you to look at slides, or the text on one side, and try
things out on the other. 
* You could also have the slides and text up for extra study potential!
---
# Navigating the System
* Now that you can use the terminal, try running some commands. 
* The commands we're going to talk about in the coming slides are:
	1. `ls`
	2. `cat`
	3. `less`
	4. `pico`
	5. `man`
	6. `cd`
	7. `pwd`
* On each of the following slides try running the commands in your
second terminal. 
---
# ls and cd
* `ls` is used to `l`i`s`t the contents of a directory
* `cd` is used to `c`hange `d`irectory

```bash
cd ~ 
ls
```

* The above code snippet will switch to your home directory
and list the content. 
 * `~` is a shorthand character for the current user's home directory
---
# cat and less
* `cat` is short for con`cat`enate
 * It can be used to display files to standard out (stdout)
 * It is designed to concatenate all files passed to it to
   stdout
* `less` is a paging tool
 * When the output of a command is too big to display on the screen
   the `less` command will allow you to scroll through it. 

```bash
cat /boot/grub/grub.cfg | less
```
* The above code will display the grub configuration file in the less pager
---
# Put that in your | and smoke it
* The | character, or pipe character is used to pass character from the 
standard output of one command to the command on the right of the pipe. 
* These can be stacked if necessary:
```bash
cat /boot/grub/grub.cfg | grep "#" | less
```
* For this, just know that grep can be used to search for strings, like 
a "#" character
* What the command does is `cat` the grub config file to `grep`, which searches
for the "#" character and only displays those lines, and then pages the 
result of that search with `less`
---
# man and pwd
* These commands will both help you tremendously in the beginning, and future, 
of your hopefully long linux using career
* `man` when coupled with a command's name will give you details about using
that command
 * i.e. `man ls` will give you the manual for the ls command
* `pwd` will show you what directory you are currently in in your terminal.
 * This is very useful when navigating complex application folders
---
# pico
* This command deserves a few slides for itself
* In your other terminal, run the `pico` command
* The `pico newfile` text editor is a common, small, and easy to use 
  terminal-based text editor
---
# pico: Editing
* `pico` makes it pretty straight forward to edit files: Just start typing
* Some linux text editors are very difficult to use, but `pico` works.
* When you have added some text to your file, press `CTRL+o` to save (output)
  the file
* To exit the app press `CTRL+x`
* In the `pico` editor you can press `CTRL+g` to get help for pico
 * You should be able to `cat` your 'newfile' in your working directory
---
# Conclusion
* In this lesson we looked at what Linux is, and the very basics of its history.
* We learned about the Linux philosophy and ecosystem
 * You should take the time to go read up on the different flavors of linux
* We covered some commands, and started learning how *stream redirection* works
by way of piping

---
# Lab - Markdown
* Markdown is a text formatting markup language that can be used to format files
* `pico` does some markdown highlighting by default. 
* In the lab, you will learn some basic formatting characters and how to save
markdown files in a new "notes" directory
---
# Next Steps
* After you are done reading the slides, close the presentation by pressing `q`
* `cd` to the `~/edu/mod0/` folder and look around! 
